"""Formula AllCode Robot Buggy functions"""

import serial as _serial
import sys as _sys

from sys import platform as _platform

if _platform == "win32":
    if (_sys.version_info.major == 2):
        import _winreg as _winreg
    else:
        import winreg as _winreg


class Create:
    __ser = _serial.Serial()
    
    def __init__(self):
        self.__ser.close()
        return;
    
    def ComOpen(self, port):
        """Open a communication link to the robot
        
            pt = the COM port to open
        
        """
        
        if _platform == "linux" or _platform == "linux2":
            # linux
            s = '/dev/rfcomm{0}'.format(port)
        elif _platform == "darwin":
            # MAC OS X
            print("Error - MAC OS TODO")
        elif _platform == "win32":
            # Windows
            s = '\\\\.\\COM{0}'.format(port)
        else:
            print("Error - unsupported platform")

        self.__ser = _serial.Serial(port=s,\
                            baudrate=115200,\
                            parity=_serial.PARITY_NONE,\
                            stopbits=_serial.STOPBITS_ONE,\
                            bytesize=_serial.EIGHTBITS,\
                            timeout=1)
        #TODO: add checking to ensure port is open
        return;

    def ComClose(self):
        self.__ser.close()
        return;

    def _comlist(self):
        #TODO: this is Windows-only at the moment
        if _platform == "win32":
            key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, 'HARDWARE\\DEVICEMAP\\SERIALCOMM')
            i = 0
            while True:
                try:
                    name = _winreg.EnumValue(key, i)[1][3:]
                except OSError:
                    #no more COM ports
                    break
                yield name #, '\\\\.\\{0}'.format(name)
                i += 1

            _winreg.CloseKey(key)
        
    def ComQuery(self, port):
        #TODO
        comlist = self._comlist()
        print (comlist)
        return;

    def ComFindFirst(self):
        #TODO
        return;

##    def Test(self):
##        #TODO: this is Windows-only at the moment
##        key = _winreg.OpenKey(_winreg.HKEY_LOCAL_MACHINE, 'HARDWARE\\DEVICEMAP\\SERIALCOMM')
##        i = 0
##        while True:
##            try:
##                name = _winreg.EnumValue(key, i)[1][3:]
##            except OSError:
##                #no more COM ports
##                break
##            yield name #, '\\\\.\\{0}'.format(name)
##            i += 1
##
##        _winreg.CloseKey(key)





        

    def LEDWrite(self, i):
        s = 'LEDWrite {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def LEDOn(self, i):
        s = 'LEDOn {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def LEDOff(self, i):
        s = 'LEDOff {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def ReadSwitch(self, i):
        s = 'ReadSwitch {0}\n'.format(i)
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadSwitch: Bad return!")
            #raise
        return(r);

    def ReadIR(self, i):
        s = 'ReadIR {0}\n'.format(i)
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadIR: Bad return!")
        return(r);

    def ReadLine(self, i):
        s = 'ReadLine {0}\n'.format(i)
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadLine: Bad return!")
        return(r);

    def ReadLight(self):
        s = 'ReadLight\n'
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadLight: Bad return!")
        return(r);

    def ReadMic(self):
        s = 'ReadMic\n'
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadMic: Bad return!")
        return(r);

    def ReadAxis(self, i):
        s = 'ReadAxis {0}\n'.format(i)
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadAxis: Bad return!")
        return(r);

    def ReadBearing(self):
        s = 'ReadBearing\n'
        self.__ser.write(s.encode())
        r = 0
        try:
            r = int(self.__ser.readline().rstrip())
        except ValueError:
            print("ReadBearing: Bad return!")
        return(r);

    def SetMotors(self, a, b):
        s = 'SetMotors {0} {1}\n'.format(a,b)
        self.__ser.write(s.encode())
        return;

    def SetLogoSpeed(self, i):
        s = 'SetLogoSpeed {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def Forwards(self, i):
        s = 'Forwards {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def Backwards(self, i):
        s = 'Backwards {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def Left(self, i):
        s = 'Left {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def Right(self, i):
        s = 'Right {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def LCDClear(self):
        s = 'LCDClear\n'
        self.__ser.write(s.encode())
        return;

    def LCDPrint(self, x, y, i):
        s = 'LCDPrint {0} {1} {2}\n'.format(x,y,i)
        self.__ser.write(s.encode())
        return;

    def LCDNumber(self, x, y, i):
        s = 'LCDNumber {0} {1} {2}\n'.format(x,y,i)
        self.__ser.write(s.encode())
        return;

    def LCDPixel(self, x, y, i):
        s = 'LCDPixel {0} {1} {2}\n'.format(x,y,i)
        self.__ser.write(s.encode())
        return;

    def LCDLine(self, x1, y1, x2, y2):
        s = 'LCDLine {0} {1} {2} {3}\n'.format(x1,y1,x2,y2)
        self.__ser.write(s.encode())
        return;

    def LCDRect(self, x1, y1, x2, y2, a, b):
        s = 'LCDRect {0} {1} {2} {3} {4} {5}\n'.format(x1,y1,x2,y2,a,b)
        self.__ser.write(s.encode())
        return;

    def LCDBacklight(self, i):
        s = 'LCDBacklight {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def LCDVerbose(self, i):
        s = 'LCDVerbose {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def PlayNote(self, a, b):
        s = 'PlayNote {0} {1}\n'.format(a,b)
        self.__ser.write(s.encode())
        return;

    def ServoEnable(self, i):
        s = 'ServoEnable {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def ServoDisable(self, i):
        s = 'ServoDisable {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;

    def ServoSetPos(self, a, b):
        s = 'ServoSetPos {0} {1}\n'.format(a,b)
        self.__ser.write(s.encode())
        return;

    def ServoAutoMove(self, a, b):
        s = 'ServoAutoMove {0} {1}\n'.format(a,b)
        self.__ser.write(s.encode())
        return;

    def ServoMoveSpeed(self, i):
        s = 'ServoMoveSpeed {0}\n'.format(i)
        self.__ser.write(s.encode())
        return;




    
